﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestVoxelRenderQuery
{
    public class YawPitchCamera
    {

        public static Vector3 CameraPosition = new Vector3(165.79764f, 155.7133f, 222.13596f);
        public static Matrix YawPitchMatrix;

        public static float Yaw;
        public static float Pitch;

        public static float DPI = 0.0025f;
        public static float Velocity = 60;

        public static int Width;
        public static int Height;

        private static int oldX, oldY;

        public static void Initialize()
        {
            oldX = Width / 2;
            oldY = Height / 2;
        }

        public static void Move(Vector3 direction)
        {
            Matrix rotation = Matrix.CreateRotationY(Yaw);
            Vector3 transformed = Vector3.Transform(direction, rotation);

            transformed *= Velocity;
            CameraPosition += transformed;
        }


        public static void Update()
        {
            float dX = Mouse.GetState().X - oldX;
            float dY = Mouse.GetState().Y - oldY;

            Pitch += DPI * dY;
            Yaw += DPI * dX;

            Pitch = MathHelper.Clamp(Pitch, -1.5f, 1.5f);

            YawPitchMatrix = Matrix.CreateRotationX(Pitch) * Matrix.CreateRotationY(Yaw);

            Mouse.SetPosition(Width / 2, Height / 2);
        }



    }
}
